您的位置:首页 > 其它

汽车加油行驶问题专题

2014-11-08 20:04 267 查看
Example one:

Link:http://poj.org/problem?id=2431

Problem:

Expedition

Time Limit: 1000MSMemory Limit: 65536K
Total Submissions: 7384Accepted: 2190
Description

A group of cows grabbed a truck and ventured on an expedition deep into the jungle. Being rather poor drivers, the cows unfortunately managed to run over a rock and puncture the truck's fuel tank. The truck now leaks one unit of fuel every unit of distance
it travels.

To repair the truck, the cows need to drive to the nearest town (no more than 1,000,000 units distant) down a long, winding road. On this road, between the town and the current location of the truck, there are N (1 <= N <= 10,000) fuel stops where the cows
can stop to acquire additional fuel (1..100 units at each stop).

The jungle is a dangerous place for humans and is especially dangerous for cows. Therefore, the cows want to make the minimum possible number of stops for fuel on the way to the town. Fortunately, the capacity of the fuel tank on their truck is so large that
there is effectively no limit to the amount of fuel it can hold. The truck is currently L units away from the town and has P units of fuel (1 <= P <= 1,000,000).

Determine the minimum number of stops needed to reach the town, or if the cows cannot reach the town at all.

Input

* Line 1: A single integer, N

* Lines 2..N+1: Each line contains two space-separated integers describing a fuel stop: The first integer is the distance from the town to the stop; the second is the amount of fuel available at that stop.

* Line N+2: Two space-separated integers, L and P
Output

* Line 1: A single integer giving the minimum number of fuel stops necessary to reach the town. If it is not possible to reach the town, output -1.
Sample Input
4
4 4
5 2
11 5
15 10
25 10

Sample Output
2

Hint

INPUT DETAILS:

The truck is 25 units away from the town; the truck has 10 units of fuel. Along the road, there are 4 fuel stops at distances 4, 5, 11, and 15 from the town (so these are initially at distances 21, 20, 14, and 10 from the truck). These fuel stops can supply
up to 4, 2, 5, and 10 units of fuel, respectively.

OUTPUT DETAILS:

Drive 10 units, stop to acquire 10 more units of fuel, drive 4 more units, stop to acquire 5 more units of fuel, then drive to the town.
Source

USACO 2005 U S Open Gold
Problem solution:greedy algorithm。

思想:贪心。就是每经过一个加油站,就把该加油站存起来,因为要求求出次数最少,所以每次加油要尽可能的多。这里用到C++中STL的优先队列实现当汽车油为0的时候,总是选择前面经过的加油站能够提供最多油的加油站进行加油,如果此时队列为空,说明无法到达下一站,输出"-1",否则加油次数加1。注意要把终点当成是最后一个加油站。

#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cmath>
#include<queue>
using namespace std;
const int maxn=10011;
struct node{
	int d;
	int f;
	bool operator <(const node &a)const
	{
		return f<a.f;
	}
}stop[maxn];
priority_queue<node>Q;
bool cmp(node a,node b)
{
	return a.d<b.d;
}
int main()
{
	int i,ans,n,L,p,dd,fg;
	while(scanf("%d",&n)==1)
	{
		for(i=0;i<n;i++)
		{
			scanf("%d%d",&stop[i].d,&stop[i].f);
		}
		scanf("%d%d",&L,&p);
		for(i=0;i<n;i++)
		{
			stop[i].d=L-stop[i].d;
		}
		stop
.d=L;
		stop
.f=0;
		sort(stop,stop+n+1,cmp);
		ans=0;
		dd=0;
		fg=1;
		while(!Q.empty())
		Q.pop();
		for(i=0;i<=n;i++)
		{
			if(p>=stop[i].d-dd)
			{
				p-=stop[i].d-dd;
				Q.push(stop[i]);
				dd=stop[i].d;
			}
			else
			{
				while(p<stop[i].d-dd)
				{
					if(Q.empty())
					{
						ans=-1;
						fg=0;
						break;
					}
					p+=Q.top().f;
					ans++;
					Q.pop();
				}
				if(fg)
				{
				p-=stop[i].d-dd;
				dd=stop[i].d;
				Q.push(stop[i]);
			    }
			    else
			    break;
			}
		}
		printf("%d\n",ans);
	}
}


Example one:

Link:http://poj.org/problem?id=2431

Problem:
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: